'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      ArrowFunctionExpression: function ArrowFunctionExpression(path, state) {
        var functionShadowed = state.opts.functionShadowed;

        if (functionShadowed) {
          path.arrowFunctionToShadowed();
        }
      },
      ClassDeclaration: function ClassDeclaration(path) {
        var node = path.node;
        var superClass = node.superClass;

        var ref = node.id;
        if (path.get('body').node.body.length > 1) {
          return;
        }
        var render_block = path.get('body').node.body.filter(function (b) {
          return b.key.name === 'render';
        });
        var block_expression = render_block[0].body.body[0].expression;
        if (superClass.object && superClass.property && !t.isIdentifier(superClass.object, { name: 'react' }) && !t.isIdentifier(superClass.property, { name: 'Component' }) || !t.isIdentifier(superClass, { name: 'Component' })) {
          path.stop();
          return;
        }
        path.replaceWith(t.variableDeclaration('const', [t.variableDeclarator(ref, t.arrowFunctionExpression([t.identifier('props')], t.blockStatement([t.returnStatement(block_expression)])))]));
      },
      MemberExpression: function MemberExpression(path) {
        var node = path.node;

        if (!t.isThisExpression(node.object)) {
          return;
        }
        if (!t.isIdentifier(node.property, { name: 'props' })) {
          path.stop();
          return;
        }
        path.replaceWith(t.identifier('props'));
      }
    }
  };
};